diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/object-vector.h ns-3.31/src/core/model/object-vector.h
--- ns-3.30.1/src/core/model/object-vector.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/object-vector.h	2020-06-27 17:38:30.000000000 -0700
@@ -82,7 +82,8 @@
 {
   struct MemberStdContainer : public ObjectPtrContainerAccessor
   {
-    virtual bool DoGetN(const ObjectBase *object, std::size_t *n) const {
+    virtual bool DoGetN (const ObjectBase *object, std::size_t *n) const
+    {
       const T *obj = dynamic_cast<const T *> (object);
       if (obj == 0)
         {
@@ -91,7 +92,8 @@
       *n = (obj->*m_memberVector).size ();
       return true;
     }
-    virtual Ptr<Object> DoGet(const ObjectBase *object, std::size_t i, std::size_t *index) const {
+    virtual Ptr<Object> DoGet (const ObjectBase *object, std::size_t i, std::size_t *index) const
+    {
       const T *obj = static_cast<const T *> (object);
       typename U::const_iterator begin = (obj->*m_memberVector).begin ();
       typename U::const_iterator end = (obj->*m_memberVector).end ();
@@ -124,17 +126,17 @@
 template <typename T, typename U, typename INDEX>
 Ptr<const AttributeAccessor>
 MakeObjectVectorAccessor (Ptr<U> (T::*get)(INDEX) const,
-			  INDEX (T::*getN)(void) const)
+                          INDEX (T::*getN)(void) const)
 {
-  return MakeObjectPtrContainerAccessor<T,U,INDEX>(get, getN);
+  return MakeObjectPtrContainerAccessor<T,U,INDEX> (get, getN);
 }
 
 template <typename T, typename U, typename INDEX>
 Ptr<const AttributeAccessor>
 MakeObjectVectorAccessor (INDEX (T::*getN)(void) const,
-			  Ptr<U> (T::*get)(INDEX) const)
+                          Ptr<U> (T::*get)(INDEX) const)
 {
-  return MakeObjectPtrContainerAccessor<T,U,INDEX>(get, getN);
+  return MakeObjectPtrContainerAccessor<T,U,INDEX> (get, getN);
 }
 
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/pointer.h ns-3.31/src/core/model/pointer.h
--- ns-3.30.1/src/core/model/pointer.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/pointer.h	2020-06-27 17:38:30.000000000 -0700
@@ -37,7 +37,7 @@
 {
 public:
   PointerValue ();
-  
+
   /**
    * Construct this PointerValue by referencing an explicit Object.
    *
@@ -70,7 +70,7 @@
   /**
    * Cast to an Object of type \c T.
    * \tparam T \explicit The type to cast to.
-   */ 
+   */
   template <typename T>
   operator Ptr<T> () const;
 
@@ -94,7 +94,7 @@
 };
 
 
-class PointerChecker : public AttributeChecker 
+class PointerChecker : public AttributeChecker
 {
 public:
 
@@ -104,7 +104,7 @@
    */
   virtual TypeId GetPointeeTypeId (void) const = 0;
 };
-  
+
 /**
  * Create a PointerChecker for a type.
  * \tparam T \explicit The underlying type.
@@ -129,7 +129,8 @@
 template <typename T>
 class PointerChecker : public ns3::PointerChecker
 {
-  virtual bool Check (const AttributeValue &val) const {
+  virtual bool Check (const AttributeValue &val) const
+  {
     const PointerValue *value = dynamic_cast<const PointerValue *> (&val);
     if (value == 0)
       {
@@ -146,20 +147,25 @@
       }
     return true;
   }
-  virtual std::string GetValueTypeName (void) const {
+  virtual std::string GetValueTypeName (void) const
+  {
     return "ns3::PointerValue";
   }
-  virtual bool HasUnderlyingTypeInformation (void) const {
+  virtual bool HasUnderlyingTypeInformation (void) const
+  {
     return true;
   }
-  virtual std::string GetUnderlyingTypeInformation (void) const {
+  virtual std::string GetUnderlyingTypeInformation (void) const
+  {
     TypeId tid = T::GetTypeId ();
     return "ns3::Ptr< " + tid.GetName () + " >";
   }
-  virtual Ptr<AttributeValue> Create (void) const {
+  virtual Ptr<AttributeValue> Create (void) const
+  {
     return ns3::Create<PointerValue> ();
   }
-  virtual bool Copy (const AttributeValue &source, AttributeValue &destination) const {
+  virtual bool Copy (const AttributeValue &source, AttributeValue &destination) const
+  {
     const PointerValue *src = dynamic_cast<const PointerValue *> (&source);
     PointerValue *dst = dynamic_cast<PointerValue *> (&destination);
     if (src == 0 || dst == 0)
@@ -169,7 +175,8 @@
     *dst = *src;
     return true;
   }
-  virtual TypeId GetPointeeTypeId (void) const {
+  virtual TypeId GetPointeeTypeId (void) const
+  {
     return T::GetTypeId ();
   }
 };
@@ -183,14 +190,14 @@
 }
 
 template <typename T>
-void 
+void
 PointerValue::Set (const Ptr<T> &object)
 {
   m_value = object;
 }
 
 template <typename T>
-Ptr<T> 
+Ptr<T>
 PointerValue::Get (void) const
 {
   T *v = dynamic_cast<T *> (PeekPointer (m_value));
@@ -204,7 +211,7 @@
 }
 
 template <typename T>
-bool 
+bool
 PointerValue::GetAccessor (Ptr<T> &v) const
 {
   Ptr<T> ptr = dynamic_cast<T*> (PeekPointer (m_value));
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/priority-queue-scheduler.cc ns-3.31/src/core/model/priority-queue-scheduler.cc
--- ns-3.30.1/src/core/model/priority-queue-scheduler.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/core/model/priority-queue-scheduler.cc	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,114 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2016 IITP
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Alexander Krotov <krotov@iitp.ru>
+ */
+
+#include "priority-queue-scheduler.h"
+#include "event-impl.h"
+#include "assert.h"
+#include "log-macros-disabled.h"
+#include "log.h"
+#include "scheduler.h"
+#include <string>
+
+/**
+ * \file
+ * \ingroup scheduler
+ * Implementation of ns3::PriorityQueueScheduler class.
+ */
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("PriorityQueueScheduler");
+
+NS_OBJECT_ENSURE_REGISTERED (PriorityQueueScheduler);
+
+TypeId
+PriorityQueueScheduler::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::PriorityQueueScheduler")
+    .SetParent<Scheduler> ()
+    .SetGroupName ("Core")
+    .AddConstructor<PriorityQueueScheduler> ()
+  ;
+  return tid;
+}
+
+PriorityQueueScheduler::PriorityQueueScheduler ()
+{
+  NS_LOG_FUNCTION (this);
+}
+PriorityQueueScheduler::~PriorityQueueScheduler ()
+{
+  NS_LOG_FUNCTION (this);
+}
+
+void
+PriorityQueueScheduler::Insert (const Event &ev)
+{
+  NS_LOG_FUNCTION (this << ev.impl << ev.key.m_ts << ev.key.m_uid);
+  m_queue.push (ev);
+}
+
+bool
+PriorityQueueScheduler::IsEmpty (void) const
+{
+  NS_LOG_FUNCTION (this);
+  return m_queue.empty ();
+}
+
+Scheduler::Event
+PriorityQueueScheduler::PeekNext (void) const
+{
+  NS_LOG_FUNCTION (this);
+  return m_queue.top ();
+}
+
+Scheduler::Event
+PriorityQueueScheduler::RemoveNext (void)
+{
+  NS_LOG_FUNCTION (this);
+  Scheduler::Event ev = m_queue.top ();
+  m_queue.pop ();
+  return ev;
+}
+
+bool
+PriorityQueueScheduler::EventPriorityQueue::remove(const Scheduler::Event &ev)
+{
+  auto it = std::find(this->c.begin(), this->c.end(), ev);
+  if (it != this->c.end())
+    {
+      this->c.erase(it);
+      std::make_heap(this->c.begin(), this->c.end(), this->comp);
+      return true;
+    }
+  else
+    {
+      return false;
+    }
+}
+
+void
+PriorityQueueScheduler::Remove (const Scheduler::Event &ev)
+{
+  NS_LOG_FUNCTION (this);
+  m_queue.remove (ev);
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/priority-queue-scheduler.h ns-3.31/src/core/model/priority-queue-scheduler.h
--- ns-3.30.1/src/core/model/priority-queue-scheduler.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/core/model/priority-queue-scheduler.h	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,113 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2006 INRIA
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
+ */
+
+#ifndef PRIORITY_QUEUE_SCHEDULER_H
+#define PRIORITY_QUEUE_SCHEDULER_H
+
+#include "scheduler.h"
+#include <functional>
+#include <algorithm>
+#include <stdint.h>
+#include <utility>
+#include <queue>
+
+/**
+ * \file
+ * \ingroup scheduler
+ * Declaration of ns3::PriorityQueueScheduler class.
+ */
+
+namespace ns3 {
+
+/**
+ * \ingroup scheduler
+ * \brief a std::priority_queue event scheduler
+ *
+ * This class implements an event scheduler using
+ * `std::priority_queue` on a `std::vector`.
+ *
+ * \par Time Complexity
+ *
+ * Operation    | Amortized %Time  | Reason
+ * :----------- | :--------------- | :-----
+ * Insert()     | Logarithmic      | `std::push_heap()`
+ * IsEmpty()    | Constant         | `std::vector::empty()`
+ * PeekNext()   | Constant         | `std::vector::front()`
+ * Remove()     | Linear           | `std::find()` and `std::make_heap()`
+ * RemoveNext() | Logarithmic      | `std::pop_heap()`
+ *
+ * \par Memory Complexity
+ *
+ * Category  | Memory                           | Reason
+ * :-------- | :------------------------------- | :-----
+ * Overhead  | 3 x `sizeof (*)`<br/>(24 bytes)  | `std::vector`
+ * Per Event | 0                                | Events stored in `std::vector` directly
+ *
+ */
+class PriorityQueueScheduler : public Scheduler
+{
+public:
+  /**
+   *  Register this type.
+   *  \return The object TypeId.
+   */
+  static TypeId GetTypeId (void);
+
+  /** Constructor. */
+  PriorityQueueScheduler ();
+  /** Destructor. */
+  virtual ~PriorityQueueScheduler ();
+
+  // Inherited
+  virtual void Insert (const Scheduler::Event &ev);
+  virtual bool IsEmpty (void) const;
+  virtual Scheduler::Event PeekNext (void) const;
+  virtual Scheduler::Event RemoveNext (void);
+  virtual void Remove (const Scheduler::Event &ev);
+
+private:
+
+  /**
+   * Custom priority_queue which supports remove,
+   * and returns entries in _increasing_ time order.
+   */
+  class EventPriorityQueue :
+    public std::priority_queue<Scheduler::Event,
+                               std::vector <Scheduler::Event>,
+                               std::greater<Scheduler::Event> >
+  {
+  public:
+
+    /**
+     * \copydoc PriorityQueueScheduler::Remove()
+     * \returns \c true if the event was found, false otherwise.
+     */
+    bool remove(const Scheduler::Event &ev);
+    
+  };  // class EventPriorityQueue
+
+  /** The event queue. */
+  EventPriorityQueue m_queue;
+
+};  // class PriorityQueueScheduler
+
+} // namespace ns3
+
+#endif /* PRIORITY_QUEUE_SCHEDULER_H */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/ptr.h ns-3.31/src/core/model/ptr.h
--- ns-3.30.1/src/core/model/ptr.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/ptr.h	2020-06-27 17:38:30.000000000 -0700
@@ -67,10 +67,10 @@
  * functions and their goal is just is save you a small
  * bit of typing.
  *
- * \tparam T \explicit The underlying type.
+ * \tparam T \explicit The type of the underlying object.
  */
 template <typename T>
-class Ptr 
+class Ptr
 {
 private:
 
@@ -78,15 +78,16 @@
   T *m_ptr;
 
   /** Helper to test for null pointer. */
-  class Tester {
+  class Tester
+  {
   private:
     /** Disable delete (by virtue that this is unimplemented). */
     void operator delete (void *);
   };
-  
+
   /** Interoperate with const instances. */
   friend class Ptr<const T>;
-  
+
   /**
    * Get a permanent pointer to the underlying object.
    *
@@ -94,11 +95,12 @@
    * to returning to the caller so the caller is
    * responsible for calling Unref himself.
    *
+   * \tparam U \deduced The actual type of the argument and return pointer.
    * \param [in] p Smart pointer
    * \return The pointer managed by this smart pointer.
    */
   template <typename U>
-  friend U *GetPointer (const Ptr<U> &p);
+  friend U * GetPointer (const Ptr<U> &p);
   /**
    * Get a temporary pointer to the underlying object.
    *
@@ -106,15 +108,16 @@
    * to returning to the caller so the caller is not
    * responsible for calling Unref himself.
    *
+   * \tparam U \deduced The actual type of the argument and return pointer.
    * \param [in] p Smart pointer
    * \return The pointer managed by this smart pointer.
    */
   template <typename U>
-  friend U *PeekPointer (const Ptr<U> &p);
+  friend U * PeekPointer (const Ptr<U> &p);
 
   /** Mark this as a a reference by incrementing the reference count. */
   inline void Acquire (void) const;
-  
+
 public:
   /** Create an empty smart pointer */
   Ptr ();
@@ -147,11 +150,11 @@
   /**
    * Copy, removing \c const qualifier.
    *
-   * \tparam U \deduced The underlying type of the \c const object.
+   * \tparam U \deduced The type underlying the Ptr being copied.
    * \param [in] o The Ptr to copy.
    */
   template <typename U>
-  Ptr (Ptr<U> const &o); 
+  Ptr (Ptr<U> const &o);
   /** Destructor. */
   ~Ptr ();
   /**
@@ -210,143 +213,27 @@
  * Create class instances by constructors with varying numbers
  * of arguments and return them by Ptr.
  *
- * These methods work for any class \c T.
+ * This template work for any class \c T derived from ns3::SimpleRefCount
  *
  * \see CreateObject for methods to create derivatives of ns3::Object
  */
 /** @{ */
 /**
- * \tparam T \explicit The type of class object to create.
- * \return A Ptr to the newly created \c T.
- */
-template <typename T>
-Ptr<T> Create (void);
-
-/**
- * \tparam T  \explicit The type of class object to create.
- * \tparam T1 \deduced The type of the first constructor argument.
- * \param  [in] a1 The first constructor argument.
- * \return A Ptr to the newly created \c T.
- */
-template <typename T,
-          typename T1>
-Ptr<T> Create (T1 a1);
-
-/**
- * \tparam T  \explicit The type of class object to create.
- * \tparam T1 \deduced The type of the first constructor argument.
- * \tparam T2 \deduced The type of the second constructor argument.
- * \param  [in] a1 The first constructor argument.
- * \param  [in] a2 The second constructor argument.
- * \return A Ptr to the newly created \c T.
- */
-template <typename T,
-          typename T1, typename T2>
-Ptr<T> Create (T1 a1, T2 a2);
-
-/**
- * \tparam T  \explicit The type of class object to create.
- * \tparam T1 \deduced The type of the first constructor argument.
- * \tparam T2 \deduced The type of the second constructor argument.
- * \tparam T3 \deduced The type of the third constructor argument.
- * \param  [in] a1 The first constructor argument.
- * \param  [in] a2 The second constructor argument.
- * \param  [in] a3 The third constructor argument.
- * \return A Ptr to the newly created \c T.
- */
-template <typename T,
-          typename T1, typename T2,
-          typename T3>
-Ptr<T> Create (T1 a1, T2 a2, T3 a3);
-
-/**
- * \tparam T  \explicit The type of class object to create.
- * \tparam T1 \deduced The type of the first constructor argument.
- * \tparam T2 \deduced The type of the second constructor argument.
- * \tparam T3 \deduced The type of the third constructor argument.
- * \tparam T4 \deduced The type of the fourth constructor argument.
- * \param  [in] a1 The first constructor argument.
- * \param  [in] a2 The second constructor argument.
- * \param  [in] a3 The third constructor argument.
- * \param  [in] a4 The fourth constructor argument.
- * \return A Ptr to the newly created \c T.
- */
-template <typename T,
-          typename T1, typename T2,
-          typename T3, typename T4>
-Ptr<T> Create (T1 a1, T2 a2, T3 a3, T4 a4);
-
-/**
- * \tparam T  \explicit The type of class object to create.
- * \tparam T1 \deduced The type of the first constructor argument.
- * \tparam T2 \deduced The type of the second constructor argument.
- * \tparam T3 \deduced The type of the third constructor argument.
- * \tparam T4 \deduced The type of the fourth constructor argument.
- * \tparam T5 \deduced The type of the fifth constructor argument.
- * \param  [in] a1 The first constructor argument.
- * \param  [in] a2 The second constructor argument.
- * \param  [in] a3 The third constructor argument.
- * \param  [in] a4 The fourth constructor argument.
- * \param  [in] a5 The fifth constructor argument.
- * \return A Ptr to the newly created \c T.
- */
-template <typename T,
-          typename T1, typename T2,
-          typename T3, typename T4,
-          typename T5>
-Ptr<T> Create (T1 a1, T2 a2, T3 a3, T4 a4, T5 a5);
-
-/**
  * \tparam T  \explicit The type of class object to create.
- * \tparam T1 \deduced The type of the first constructor argument.
- * \tparam T2 \deduced The type of the second constructor argument.
- * \tparam T3 \deduced The type of the third constructor argument.
- * \tparam T4 \deduced The type of the fourth constructor argument.
- * \tparam T5 \deduced The type of the fifth constructor argument.
- * \tparam T6 \deduced The type of the sixth constructor argument.
- * \param  [in] a1 The first constructor argument.
- * \param  [in] a2 The second constructor argument.
- * \param  [in] a3 The third constructor argument.
- * \param  [in] a4 The fourth constructor argument.
- * \param  [in] a5 The fifth constructor argument.
- * \param  [in] a6 The sixth constructor argument.
+ * \tparam Ts \deduced Types of the constructor arguments.
+ * \param  [in] args Constructor arguments.
  * \return A Ptr to the newly created \c T.
  */
 template <typename T,
-          typename T1, typename T2,
-          typename T3, typename T4,
-          typename T5, typename T6>
-Ptr<T> Create (T1 a1, T2 a2, T3 a3, T4 a4, T5 a5, T6 a6);
+          typename... Ts>
+Ptr<T> Create (Ts... args);
 
-/**
- * \tparam T  \explicit The type of class object to create.
- * \tparam T1 \deduced The type of the first constructor argument.
- * \tparam T2 \deduced The type of the second constructor argument.
- * \tparam T3 \deduced The type of the third constructor argument.
- * \tparam T4 \deduced The type of the fourth constructor argument.
- * \tparam T5 \deduced The type of the fifth constructor argument.
- * \tparam T6 \deduced The type of the sixth constructor argument.
- * \tparam T7 \deduced The type of the seventh constructor argument.
- * \param  [in] a1 The first constructor argument.
- * \param  [in] a2 The second constructor argument.
- * \param  [in] a3 The third constructor argument.
- * \param  [in] a4 The fourth constructor argument.
- * \param  [in] a5 The fifth constructor argument.
- * \param  [in] a6 The sixth constructor argument.
- * \param  [in] a7 The seventh constructor argument.
- * \return A Ptr to the newly created \c T.
- */
-template <typename T,
-          typename T1, typename T2,
-          typename T3, typename T4,
-          typename T5, typename T6,
-          typename T7>
-Ptr<T> Create (T1 a1, T2 a2, T3 a3, T4 a4, T5 a5, T6 a6, T7 a7);
 /** @}*/
 
 /**
  * \ingroup ptr
  * Output streamer.
+ * \tparam T \deduced The type of the underlying Object.
  * \param [in,out] os The output stream.
  * \param [in] p The Ptr.
  * \returns The stream.
@@ -421,6 +308,7 @@
  * \ingroup ptr
  * Comparison operator applied to the underlying pointers.
  *
+ * \tparam T \deduced The type of the operands.
  * \param [in] lhs The left operand.
  * \param [in] rhs The right operand.
  * \return The comparison on the underlying pointers.
@@ -435,7 +323,7 @@
 template <typename T>
 bool operator >= (const Ptr<T> &lhs, const Ptr<T> &rhs);
 /** @} */
-  
+
 /**
  * Return a copy of \c p with its stored pointer const casted from
  * \c T2 to \c T1.
@@ -448,7 +336,7 @@
 template <typename T1, typename T2>
 Ptr<T1> const_pointer_cast (Ptr<T2> const&p);
 
-// Duplicate of struct CallbackTraits<T> as defined in callback.h  
+// Duplicate of struct CallbackTraits<T> as defined in callback.h
 template <typename T>
 struct CallbackTraits;
 
@@ -460,7 +348,7 @@
  *
  * This is the specialization for Ptr types.
  *
- * \tparam T \deduced The base object type.
+ * \tparam T \deduced The type of the underlying object.
  */
 template <typename T>
 struct CallbackTraits<Ptr<T> >
@@ -487,7 +375,7 @@
  *
  * This is the specialization for Ptr types.
  *
- * \tparam T \explicit The class type.
+ * \tparam T \deduced The type of the underlying object.
  */
 template <typename T>
 struct EventMemberImplObjTraits<Ptr<T> >
@@ -496,7 +384,8 @@
    * \param [in] p Object pointer
    * \return A reference to the object pointed to by p
    */
-  static T &GetReference (Ptr<T> p) {
+  static T & GetReference (Ptr<T> p)
+  {
     return *PeekPointer (p);
   }
 };
@@ -512,52 +401,10 @@
  *  friend non-member function implementations
  ************************************************/
 
-template <typename T>
-Ptr<T> Create (void)
-{
-  return Ptr<T> (new T (), false);
-}
-
-template <typename T, typename T1>
-Ptr<T> Create (T1 a1)
-{
-  return Ptr<T> (new T (a1), false);
-}
-
-template <typename T, typename T1, typename T2>
-Ptr<T> Create (T1 a1, T2 a2)
-{
-  return Ptr<T> (new T (a1, a2), false);
-}
-
-template <typename T, typename T1, typename T2, typename T3>
-Ptr<T> Create (T1 a1, T2 a2, T3 a3)
-{
-  return Ptr<T> (new T (a1, a2, a3), false);
-}
-
-template <typename T, typename T1, typename T2, typename T3, typename T4>
-Ptr<T> Create (T1 a1, T2 a2, T3 a3, T4 a4)
-{
-  return Ptr<T> (new T (a1, a2, a3, a4), false);
-}
-
-template <typename T, typename T1, typename T2, typename T3, typename T4, typename T5>
-Ptr<T> Create (T1 a1, T2 a2, T3 a3, T4 a4, T5 a5)
-{
-  return Ptr<T> (new T (a1, a2, a3, a4, a5), false);
-}
-
-template <typename T, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6>
-Ptr<T> Create (T1 a1, T2 a2, T3 a3, T4 a4, T5 a5, T6 a6)
-{
-  return Ptr<T> (new T (a1, a2, a3, a4, a5, a6), false);
-}
-
-template <typename T, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7>
-Ptr<T> Create (T1 a1, T2 a2, T3 a3, T4 a4, T5 a5, T6 a6, T7 a7)
+template <typename T, typename... Ts>
+Ptr<T> Create (Ts... args)
 {
-  return Ptr<T> (new T (a1, a2, a3, a4, a5, a6, a7), false);
+  return Ptr<T> (new T (args...), false);
 }
 
 template <typename U>
@@ -581,42 +428,42 @@
 }
 
 template <typename T1, typename T2>
-bool 
+bool
 operator == (Ptr<T1> const &lhs, T2 const *rhs)
 {
   return PeekPointer (lhs) == rhs;
 }
 
 template <typename T1, typename T2>
-bool 
+bool
 operator == (T1 const *lhs, Ptr<T2> &rhs)
 {
   return lhs == PeekPointer (rhs);
 }
 
 template <typename T1, typename T2>
-bool 
+bool
 operator != (Ptr<T1> const &lhs, T2 const *rhs)
 {
   return PeekPointer (lhs) != rhs;
 }
 
 template <typename T1, typename T2>
-bool 
+bool
 operator != (T1 const *lhs, Ptr<T2> &rhs)
 {
   return lhs != PeekPointer (rhs);
 }
 
 template <typename T1, typename T2>
-bool 
+bool
 operator == (Ptr<T1> const &lhs, Ptr<T2> const &rhs)
 {
   return PeekPointer (lhs) == PeekPointer (rhs);
 }
 
 template <typename T1, typename T2>
-bool 
+bool
 operator != (Ptr<T1> const &lhs, Ptr<T2> const &rhs)
 {
   return PeekPointer (lhs) != PeekPointer (rhs);
@@ -680,6 +527,7 @@
 /**
  * Return a deep copy of a Ptr.
  *
+ * \tparam T \deduced The type of the underlying object.
  * \param [in] object The object Ptr to copy.
  * \returns The copy.
  */
@@ -704,7 +552,7 @@
  ***************************************************/
 
 template <typename T>
-void 
+void
 Ptr<T>::Acquire (void) const
 {
   if (m_ptr != 0)
@@ -716,8 +564,7 @@
 template <typename T>
 Ptr<T>::Ptr ()
   : m_ptr (0)
-{
-}
+{}
 
 template <typename T>
 Ptr<T>::Ptr (T *ptr)
@@ -737,7 +584,7 @@
 }
 
 template <typename T>
-Ptr<T>::Ptr (Ptr const&o) 
+Ptr<T>::Ptr (Ptr const&o)
   : m_ptr (PeekPointer (o))
 {
   Acquire ();
@@ -751,9 +598,9 @@
 }
 
 template <typename T>
-Ptr<T>::~Ptr () 
+Ptr<T>::~Ptr ()
 {
-  if (m_ptr != 0) 
+  if (m_ptr != 0)
     {
       m_ptr->Unref ();
     }
@@ -761,13 +608,13 @@
 
 template <typename T>
 Ptr<T> &
-Ptr<T>::operator = (Ptr const& o) 
+Ptr<T>::operator = (Ptr const& o)
 {
   if (&o == this)
     {
       return *this;
     }
-  if (m_ptr != 0) 
+  if (m_ptr != 0)
     {
       m_ptr->Unref ();
     }
@@ -778,8 +625,9 @@
 
 template <typename T>
 T *
-Ptr<T>::operator -> () 
+Ptr<T>::operator -> ()
 {
+  NS_ASSERT_MSG (m_ptr, "Attempted to dereference zero pointer");
   return m_ptr;
 }
 
@@ -787,6 +635,7 @@
 T *
 Ptr<T>::operator -> () const
 {
+  NS_ASSERT_MSG (m_ptr, "Attempted to dereference zero pointer");
   return m_ptr;
 }
 
@@ -794,6 +643,7 @@
 T &
 Ptr<T>::operator * () const
 {
+  NS_ASSERT_MSG (m_ptr, "Attempted to dereference zero pointer");
   return *m_ptr;
 }
 
@@ -801,12 +651,13 @@
 T &
 Ptr<T>::operator * ()
 {
+  NS_ASSERT_MSG (m_ptr, "Attempted to dereference zero pointer");
   return *m_ptr;
 }
 
 template <typename T>
-bool 
-Ptr<T>::operator! () 
+bool
+Ptr<T>::operator! ()
 {
   return m_ptr == 0;
 }
@@ -814,7 +665,7 @@
 template <typename T>
 Ptr<T>::operator Tester * () const
 {
-  if (m_ptr == 0) 
+  if (m_ptr == 0)
     {
       return 0;
     }
